
{******************************************}
{                                          }
{             FastReport v3.0              }
{  IB Objects (native) components RTTI     }
{                                          }
{             IB Objects 4.5               }
{  Version-Date: 2006-01-06                }
{                                          }
{ Created by: Andreas Hesse                }
{ E-mail: delphi@ah3000.de                 }
{                                          }
{******************************************}

unit frxIB_RTTI;

interface

{$I frx.inc}

implementation

uses
  Windows, Classes, fs_iinterpreter, frxIB_Components, frxIBOSetRTTI
{$IFDEF Delphi6}
, Variants
{$ENDIF};


type
  TFunctions = class(TfsRTTIModule)
  private
    function CallMethod(Instance: TObject; ClassType: TClass; const MethodName: String; Caller: TfsMethodHelper): Variant;
  public
    constructor Create(AScript: TfsScript); override;
  end;

{ TFunctions }

constructor TFunctions.Create(AScript: TfsScript);
begin
  inherited Create(AScript);
  with AScript do
  begin
    AddClass(TfrxIB_Database, 'TfrxComponent');
    with AddClass(TfrxIB_Query, 'TfrxIBODataset') do
    begin
      AddMethod('procedure ExecSQL', CallMethod);
    end;
  end;
end;

function TFunctions.CallMethod(Instance: TObject; ClassType: TClass; const MethodName: String; Caller: TfsMethodHelper): Variant;
begin
  Result := 0;
  if ClassType = TfrxIB_Query then
  begin
    if MethodName = 'EXECSQL' then
    begin
      TfrxIB_Query(Instance).DataSet.ExecSQL;
    end;
  end
end;


initialization
  fsRTTIModules.Add(TFunctions);

finalization
  if fsRTTIModules <> nil then
    fsRTTIModules.Remove(TFunctions);

end.
